Bug 3717 - Use staffClientBaseURL and OPACBaseURL to rewrite URLs in Koha
Summary: Use staffClientBaseURL and OPACBaseURL to rewrite URLs in Koha
Status: REOPENED
Alias: None
Product: Koha
Classification: Unclassified
Component: System Administration (show other bugs)
Version: master
Hardware: PC All
: P5 - low minor (vote)
Assignee: Bugs List
QA Contact: Bugs List
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2009-10-19 05:26 UTC by Nicole C. Engard
Modified: 2019-05-04 14:31 UTC (History)
4 users (show)

See Also:
Change sponsored?: ---
Patch complexity: ---
Text to go in the release notes:
Version(s) released in:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Chris Cormack 2010-05-21 01:14:10 UTC


---- Reported by nengard@gmail.com 2009-10-19 17:26:26 ----

staffClientBaseURL and OPACBaseURL are unused in most of the code - there was a bug that requested for them to be removed, but new features have been added that use them.  In the chat below Lupin expresses that these preferences should be used for all links throughout the system.


CHAT LOG:

 <|Lupin|> nengard: I wante d to tellyou about two system preferences
[12:59]  <nengard> k
[12:59]  <|Lupin|> nengard: just checking heir names...
[13:00]  <|Lupin|> nengard: staffClientBaseURL and OPACBaseURL
[13:00]  <nengard> yep - they are for the url to your staff client and your OPAC
[13:00]  <|Lupin|> nengard: I think the manuals document them as if they work, but as far as I know they actually do _not_ work so far.
[13:00]  <ricardo> OK... I solved that bug (infinite loop)... and I'm back to the old bug (first page after staff client appears in English... Oh well. I'll leave for today. I think I'll be back here in 4 hours or so.)
[13:00]  <nengard> both need http:// in front of them
[13:00]  <nengard> Lupin - they weren't used at all - until I submitted some patches that do use them
[13:01]  <nengard> so theyll be used in 3.2
[13:01]  <|Lupin|> nengard: really !?
[13:01]  <nengard> :) yup
[13:01]  <|Lupin|> nengard: and they are used consistently everywhere in KOha now ?
[13:01]  <nengard> no - not that i know of - but i don't think they're required everywhere - are they?
[13:01]  <|Lupin|> nengard: that's really great !! I missed this feature so much !!
[13:02]  <nengard> Like I said - I know that they work for the features I wrote -but I did not fix them globally
[13:02]  <|Lupin|> nengard: well... which links according to you shold not take them into account ?
[13:02]  <nengard> Lupin - no clue :) hehe - just know that the system seems to work a-ok without them set
[13:03]  <nengard> would need a developer's input on this
[13:03]  <|Lupin|> nengard: yeah so they do not work everywhere... according to me every url generated topoint to the OPAC shold take the OPAC one into account, same for the intranet
13:04]  <|Lupin|> nengard: what I mean is that by reading the manual it's what I understood -- that all the OPAC-related urls use th opac sysperf and the same for intranet related urls and the intranet syspref. And then I realized it was not the case and was frustrated.
[13:05]  <nengard> Ahhh - okay - Lupin I'll update the description to make it clear that it's not used for everything at this time
[13:06]  <|Lupin|> nengard: /me disappointed :)
[13:06]  <nengard> Lupin - sorry :( 
[13:06]  <nengard> is there a bug for it?
[13:06]  <|Lupin|> nengard: actually the wonderfur thing would be to patch KOha so that they are used everywhere... but I realsie it's a logt of job and don't have the time myself to do it
[13:07]  <|Lupin|> nengard: yeah, but I can't remember the number right now... it was suggested to get rid of the sysprefs, but I added a comemnt to explain why it was not a good idea IMO
[13:11]  <nengard> I don't know enough about Koha programming to fix it all over on my own :( but I do think we should have a new bug report to have it fixed if you think it needs to be done
[13:12]  <|Lupin|> 've found it
[13:12]  <|Lupin|> it's http://bugs.koha.org/cgi-bin/bugzilla3/show_bug.cgi?id=2152
[13:13]  <nengard> i think we need a new bug though
[13:13]  <nengard> one that says instead of removing them we need to make the work everywhere
[13:15]  <|Lupin|> yeah that sounds good to me...
[13:15]  <|Lupin|> too bad nobody replied to the comment I did
[13:15]  <|Lupin|> would you accept to open that new bug for me please ?
[13:16]  <|Lupin|> I'm sorry, but I'm a bit reluctant to use the web interface. it is accessible but still much ime-consuming for me to go over the screen and read everything
[13:16]  <nengard> Why don't you open it and just CC me on it nengard@gmail.com
[13:16]  <nengard> oh
[13:16]  <nengard> what is your email on there then so i can CC you?
[13:18]  <|Lupin|> sebstien.hinderer@snv.jussieu.fr
[13:18]  <|Lupin|> but
[13:18]  <|Lupin|> don't need to include me in the Cc
[13:18]  <|Lupin|> I'm subscribed to koha-bugs
[13:18]  <|Lupin|> and thanks a lot for your understanding
[13:19]  <|Lupin|> fixing this is on my TODOLIST



--- Bug imported by chris@bigballofwax.co.nz 2010-05-21 01:14 UTC  ---

This bug was previously known as _bug_ 3717 at http://bugs.koha.org/cgi-bin/bugzilla3/show_bug.cgi?id=3717

Actual time not defined. Setting to 0.0

Comment 1 Paul Poulain 2011-08-02 14:15:31 UTC
still relevant, the staff syspref is used nowhere
Comment 2 Katrin Fischer 2012-04-07 17:12:31 UTC
A quick search shows that staffClientBaseURL is currently at least used by 2 scripts:
misc/load_testing/benchmark_circulation.pl
opac/opac-userupdate.pl

I am not sure if it should be used in other places too, but I think this bug can be closed until someone reports a problem with these system preferences.
Comment 3 Katrin Fischer 2012-04-07 19:46:51 UTC
I received an email from Sebastien Hinderer explaining why this bug should remain open. Copying his explanation into this bug with his permission:

The thing is, as long as this system preference is not implemented, you
have to have a virtualhost for koha. I mean, the URLs for Koha will have
to start by /
So for instance you could not have an URL such as
www.mylibrary.com/koha/.../script.pl
which was a problem for the library I was working for.
Comment 4 Katrin Fischer 2015-06-06 19:34:41 UTC
I think the title of this bug is not quite right, but not sure to rephrase it better.
Comment 5 Jon Knight 2017-12-12 15:58:10 UTC
Now that we've had things like Bug 16401 push to master which is most definitely using staffClientBaseURL (and indeed including the protocol details now) it looks like we're actively using staffClientBaseURL alot more. Its in svc/import_bib, the CAS authentication, several test suites, and (if it gets unblocked) bug 12027 will use it for Shibboleth too.

I guess the question at this point is where else in the Koha codebase does staffClientBaseURL need to appear? Having a look at some pages returned by the staff client at the moment we have a lot of "path-absolute" (in RFC 3986 terms) URIs in there.  For example "/intranet-tmpl/prog/css/mainpage.css", "/cgi-bin/koha/catalogue/search.pl", "/intranet-tmpl/prog/js/basket.js". Those look to be hard coded in the templates (eg koha-tmpl/intranet-tmpl/prog/en/modules/intranet-main.tt), so to change them will mean a large number of templates will need to be altered.  

One option might be to drop the leading slash on the path in these URLs the templates and include a BASE element in the head of the HTML output that specified the staffClientBaseURL? That would mean that people could put the Koha staff client under any base path they liked then (which I think is the major thrust of this bug report?).  Opinions?
Comment 6 Katrin Fischer 2019-05-04 14:31:02 UTC
I've rephrased it a bit. See comment 3 for the initial intent by the patch reporter. I am not sure if this is doable, but leaving open for more comments.